#include "AnimationObject.h"
#include <math.h>
#include <stdlib.h>

ARGB
AO_CheckerPattern(const Animation* anim, u32 frameIndex, ARGB pixel, i32 r, i32 c, void* priv) {
	struct AO_CheckerPattern chp = *(struct AO_CheckerPattern*)priv;

	r /= chp.squareSize;
	c /= chp.squareSize;

	if ((r + c) % 2 == 0) {
		ARGB_set(&pixel, 0xFF000000);
	}
	else {
		ARGB_set(&pixel, 0xFFFF00FF);
	}

	return pixel;
}

ARGB
AO_Square(const Animation* anim, u32 frameIndex, ARGB pixel, i32 r, i32 c, void* priv) {
	struct AO_Square* set = (struct AO_Square*)priv;

	if (0 <= r && r <= set->width && 0 <= c && c <= set->height) {
		ARGB_set(&pixel, set->color);
	}

	return pixel;
}

ARGB
AO_Circle(const Animation* anim, u32 frameIndex, ARGB pixel, i32 r, i32 c, void* priv) {
	struct AO_Circle* cir = (struct AO_Circle*)priv;

	if (r * r + c * c < cir->radius * cir->radius) {
		ARGB_set(&pixel, cir->color);
	}

	return pixel;
}

ARGB
AO_Image(const Animation* anim, u32 frameIndex, ARGB pixel, i32 r, i32 c, void* priv) {
	struct AO_Image img = *(struct AO_Image*)priv;

	if (img.noRepeat == true &&
		(c < 0 || img.img.width * img.zoom <= c ||
		 r < 0 || img.img.height * img.zoom <= r))
	{
		return pixel;
	}

	return *RGBImage_at(*(RGBImage*)priv, r / img.zoom, c / img.zoom);
}

ARGB
AO_Line(const Animation* anim, u32 frameIndex, ARGB pixel, i32 r, i32 c, void* priv) {
	struct AO_Line l = *(struct AO_Line*)priv;

	if (fabs(l.a * c + l.b * r + l.c) / sqrt(l.a * l.a + l.b * l.b) < l.width) {
		ARGB_set(&pixel, l.color);
	}

	return pixel;
}

ARGB
AO_HorSegment(const Animation* anim, u32 frameIndex, ARGB pixel, i32 r, i32 c, void* priv) {
	struct AO_HorSegment hs = *(struct AO_HorSegment*)priv;

	if (abs(r) <= hs.width && hs.left <= c && c <= hs.right) {
		ARGB_set(&pixel, hs.color);
	}

	return pixel;
}
